﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Microsoft.Phone.Controls;
using Microsoft.Xna.Framework.Media;

namespace PlayRandomSong
{
    public partial class MainPage : PhoneApplicationPage
    {
        Random random = new Random();

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            DispatcherTimer tmr = new DispatcherTimer
            {
                Interval = TimeSpan.FromSeconds(0.1)
            };
            tmr.Tick += (sender, args) =>
                {
                    albumName.Inlines.Clear();
                    artistName.Inlines.Clear();
                    songName.Inlines.Clear();
                    songArtistName.Inlines.Clear();

                    Song song = MediaPlayer.Queue.ActiveSong;

                    if (song != null)
                    {
                        albumName.Inlines.Add(new Run { Text = "Album: ", FontWeight = FontWeights.Bold });
                        albumName.Inlines.Add(new Run { Text = song.Album.Name });
                        artistName.Inlines.Add(new Run { Text = "Album Artist: ", FontWeight = FontWeights.Bold });
                        artistName.Inlines.Add(new Run { Text = song.Album.Artist.Name });
                        songName.Inlines.Add(new Run { Text = "Song: ", FontWeight = FontWeights.Bold });
                        songName.Inlines.Add(new Run { Text = song.Name });
                        songArtistName.Inlines.Add(new Run { Text = "Song Artist: ", FontWeight = FontWeights.Bold });
                        songArtistName.Inlines.Add(new Run { Text = song.Artist.Name });
                    }
                };
            tmr.Start();
        }

        void OnButtonClick(object sender, RoutedEventArgs args)
        {
            MediaLibrary mediaLib = new MediaLibrary();
            AlbumCollection albums = mediaLib.Albums;
            Album album = albums[random.Next(albums.Count)];
            SongCollection songs = mediaLib.Songs;
            Song song = songs[random.Next(songs.Count)];
            MediaPlayer.Play(song);
        }
    }
}